Index: /trunk/source/Lib/TLibCommon/TComBitStream.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComBitStream.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComBitStream.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComCABACTables.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComCABACTables.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComCABACTables.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComCABACTables.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComCABACTables.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComCABACTables.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -60,8 +60,13 @@
   
   m_skipFlag           = NULL;
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  m_bDISFlag           = NULL;
+  m_uiDISType          = NULL;
+#else
 #if H_3D_SINGLE_DEPTH
   m_singleDepthFlag     = NULL;
   m_apSingleDepthValue  = NULL;
-#endif  
+#endif
+#endif
   m_pePartSize         = NULL;
   m_pePredMode         = NULL;
@@ -181,7 +186,12 @@
 
     m_skipFlag           = new Bool[ uiNumPartition ];
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+    m_bDISFlag           = new Bool[ uiNumPartition ];
+    m_uiDISType          = (UInt*)xMalloc(UInt, uiNumPartition);
+#else
 #if H_3D_SINGLE_DEPTH
     m_singleDepthFlag     = new Bool[ uiNumPartition ];
     m_apSingleDepthValue  = (Pel*)xMalloc(Pel, uiNumPartition);
+#endif
 #endif
     m_pePartSize         = new Char[ uiNumPartition ];
@@ -327,7 +337,12 @@
 
     if ( m_skipFlag           ) { delete[] m_skipFlag;          m_skipFlag          = NULL; }
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+    if ( m_bDISFlag           ) { delete[] m_bDISFlag;   m_bDISFlag     = NULL; }
+    if ( m_uiDISType         ) { xFree(m_uiDISType);  m_uiDISType    = NULL; }
+#else
 #if H_3D_SINGLE_DEPTH
     if ( m_singleDepthFlag    ) { delete[] m_singleDepthFlag;   m_singleDepthFlag     = NULL; }
     if ( m_apSingleDepthValue ) { xFree(m_apSingleDepthValue);  m_apSingleDepthValue  = NULL; }
+#endif
 #endif
     if ( m_pePartSize         ) { delete[] m_pePartSize;        m_pePartSize        = NULL; }
@@ -491,7 +506,12 @@
     TComDataCU * pcFrom = pcPic->getCU(getAddr());
     m_skipFlag[ui]   = pcFrom->getSkipFlag(ui);
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+    m_bDISFlag[ui]   = pcFrom->getDISFlag(ui);
+    m_uiDISType[ui]  = pcFrom->getDISType(ui);
+#else
 #if H_3D_SINGLE_DEPTH
     m_singleDepthFlag[ui]    = pcFrom->getSingleDepthFlag(ui);
     m_apSingleDepthValue[ui] = pcFrom->getSingleDepthValue(ui);
+#endif
 #endif
     m_pePartSize[ui] = pcFrom->getPartitionSize(ui);
@@ -546,7 +566,12 @@
   {
     memset( m_skipFlag          + firstElement, false,                    numElements * sizeof( *m_skipFlag ) );
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+    memset( m_bDISFlag          + firstElement, false,                    numElements * sizeof( *m_bDISFlag ) );
+    memset( m_uiDISType         + firstElement,     0,                    numElements * sizeof( *m_uiDISType) );
+#else
 #if H_3D_SINGLE_DEPTH
     memset( m_singleDepthFlag     + firstElement, false,                  numElements * sizeof( *m_singleDepthFlag ) );
     memset( m_apSingleDepthValue  + firstElement,     0,                  numElements * sizeof( *m_apSingleDepthValue ) );
+#endif
 #endif
     memset( m_pePartSize        + firstElement, SIZE_NONE,                numElements * sizeof( *m_pePartSize ) );
@@ -733,7 +758,12 @@
       m_puhTransformSkip[2][ui] = 0;
       m_skipFlag[ui]   = false;
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+      m_bDISFlag[ui]   = false;
+      m_uiDISType[ui]  = 0;
+#else
 #if H_3D_SINGLE_DEPTH
       m_singleDepthFlag[ui]     = false;
       m_apSingleDepthValue[ui]  = 0;
+#endif
 #endif
       m_pePartSize[ui] = SIZE_NONE;
@@ -861,5 +891,5 @@
   memset( m_puhCbf[2],          0, iSizeInUchar );
   memset( m_puhDepth,     uiDepth, iSizeInUchar );
-#if H_3D_NBDV
+#if H_3D_NBDV && !SEC_ARP_REM_ENC_RESTRICT_K0035
   m_pDvInfo->bDV = false;
 #endif
@@ -904,7 +934,12 @@
   {
     m_skipFlag[ui]   = false;
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+    m_bDISFlag[ui]   = false;
+    m_uiDISType[ui]  = 0;
+#else
 #if H_3D_SINGLE_DEPTH
     m_singleDepthFlag[ui]   = false;
     m_apSingleDepthValue[ui]= 0;
+#endif
 #endif
     m_pePartSize[ui] = SIZE_NONE;
@@ -929,7 +964,12 @@
       m_puhTransformSkip[2][ui] = pcCU->getTransformSkip(uiPartOffset+ui,TEXT_CHROMA_V);
       m_skipFlag[ui]   = pcCU->getSkipFlag(uiPartOffset+ui);
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+      m_bDISFlag[ui]    = pcCU->getDISFlag(uiPartOffset+ui);
+      m_uiDISType[ui]   = pcCU->getDISType(uiPartOffset+ui);
+#else
 #if H_3D_SINGLE_DEPTH
       m_singleDepthFlag[ui]    = pcCU->getSingleDepthFlag(uiPartOffset+ui);
       m_apSingleDepthValue[ui] = pcCU->getSingleDepthValue(uiPartOffset+ui);
+#endif
 #endif
       m_pePartSize[ui] = pcCU->getPartitionSize(uiPartOffset+ui);
@@ -1078,8 +1118,13 @@
   
   m_skipFlag=pcCU->getSkipFlag()          + uiPart;
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  m_bDISFlag     = pcCU->getDISFlag()     + uiPart;
+  m_uiDISType    = pcCU->getDISType()     + uiPart;
+#else
 #if H_3D_SINGLE_DEPTH
   m_singleDepthFlag     = pcCU->getSingleDepthFlag()   + uiPart;
   m_apSingleDepthValue  = pcCU->getSingleDepthValue()  + uiPart;
-#endif  
+#endif
+#endif
   m_phQP=pcCU->getQP()                    + uiPart;
   m_pePartSize = pcCU->getPartitionSize() + uiPart;
@@ -1215,8 +1260,13 @@
   
   m_skipFlag           = pcCU->getSkipFlag ()             + uiAbsPartIdx;
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  m_bDISFlag           = pcCU->getDISFlag ()              + uiAbsPartIdx;
+  m_uiDISType          = pcCU->getDISType()               + uiAbsPartIdx;
+#else
 #if H_3D_SINGLE_DEPTH
   m_singleDepthFlag     = pcCU->getSingleDepthFlag ()             + uiAbsPartIdx;
   m_apSingleDepthValue  = pcCU->getSingleDepthValue ()            + uiAbsPartIdx;
-#endif  
+#endif
+#endif
   m_pePartSize         = pcCU->getPartitionSize ()        + uiAbsPartIdx;
 #if H_3D_NBDV
@@ -1290,7 +1340,12 @@
   Int sizeInChar  = sizeof( Char ) * uiNumPartition;
   memcpy( m_skipFlag   + uiOffset, pcCU->getSkipFlag(),       sizeof( *m_skipFlag )   * uiNumPartition );
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  memcpy( m_bDISFlag   + uiOffset, pcCU->getDISFlag(),       sizeof( *m_bDISFlag )   * uiNumPartition );
+  memcpy( m_uiDISType  + uiOffset, pcCU->getDISType(),       sizeof( *m_uiDISType )  * uiNumPartition);
+#else
 #if H_3D_SINGLE_DEPTH
   memcpy( m_singleDepthFlag     + uiOffset, pcCU->getSingleDepthFlag(),       sizeof( *m_singleDepthFlag )   * uiNumPartition );
   memcpy( m_apSingleDepthValue  + uiOffset, pcCU->getSingleDepthValue(),      sizeof( *m_apSingleDepthValue ) * uiNumPartition);
+#endif
 #endif
   memcpy( m_phQP       + uiOffset, pcCU->getQP(),             sizeInChar                        );
@@ -1410,7 +1465,12 @@
 
   memcpy( rpcCU->getSkipFlag() + m_uiAbsIdxInLCU, m_skipFlag, sizeof( *m_skipFlag ) * m_uiNumPartition );
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  memcpy( rpcCU->getDISFlag()  + m_uiAbsIdxInLCU, m_bDISFlag,    sizeof( *m_bDISFlag )  * m_uiNumPartition );
+  memcpy( rpcCU->getDISType()  + m_uiAbsIdxInLCU, m_uiDISType,   sizeof( *m_uiDISType ) * m_uiNumPartition );
+#else
 #if H_3D_SINGLE_DEPTH
   memcpy( rpcCU->getSingleDepthFlag()  + m_uiAbsIdxInLCU, m_singleDepthFlag,    sizeof( *m_singleDepthFlag ) * m_uiNumPartition );
   memcpy( rpcCU->getSingleDepthValue() + m_uiAbsIdxInLCU, m_apSingleDepthValue, sizeof( *m_apSingleDepthValue ) * m_uiNumPartition);
+#endif
 #endif
   memcpy( rpcCU->getQP() + m_uiAbsIdxInLCU, m_phQP, sizeInChar  );
@@ -1525,7 +1585,12 @@
   Int sizeInChar  = sizeof( Char ) * uiQNumPart;
   memcpy( rpcCU->getSkipFlag()       + uiPartOffset, m_skipFlag,   sizeof( *m_skipFlag )   * uiQNumPart );
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  memcpy( rpcCU->getDISFlag()  + uiPartOffset, m_bDISFlag,    sizeof( *m_bDISFlag )   * uiQNumPart );
+  memcpy( rpcCU->getDISType()  + uiPartOffset, m_uiDISType,   sizeof( *m_uiDISType )  * uiQNumPart );
+#else
 #if H_3D_SINGLE_DEPTH
   memcpy( rpcCU->getSingleDepthFlag()  + uiPartOffset, m_singleDepthFlag,    sizeof( *m_singleDepthFlag )   * uiQNumPart );
   memcpy( rpcCU->getSingleDepthValue() + uiPartOffset, m_apSingleDepthValue, sizeof( *m_apSingleDepthValue ) * uiQNumPart);
+#endif
 #endif
   memcpy( rpcCU->getQP() + uiPartOffset, m_phQP, sizeInChar );
@@ -2323,6 +2388,8 @@
     Int iPictureHeight = depthPicYuv->getHeight();
     
+#if !HS_DBBP_CLEAN_K0048
     Int iWidth  = uiWidth;
     Int iHeight = uiHeight;
+#endif
     
     Bool depthRefineFlag = false;
@@ -2337,6 +2404,11 @@
     }
     
+#if HS_DBBP_CLEAN_K0048
+    Int depthPosX = Clip3(0,   iPictureWidth - 1,  iBlkX + ((cDv.getHor()+2)>>2));
+    Int depthPosY = Clip3(0,   iPictureHeight - 1, iBlkY + ((cDv.getVer()+2)>>2));
+#else
     Int depthPosX = Clip3(0,   iPictureWidth - iWidth,  iBlkX + ((cDv.getHor()+2)>>2));
     Int depthPosY = Clip3(0,   iPictureHeight- iHeight, iBlkY + ((cDv.getVer()+2)>>2));
+#endif
     
     pDepthPels = depthPicYuv->getLumaAddr() + depthPosX + depthPosY * uiDepthStride;
@@ -2382,4 +2454,5 @@
 Void TComDataCU::setCbfSubParts( UInt uiCbf, TextType eTType, UInt uiAbsPartIdx, UInt uiDepth )
 {
+
   UInt uiCurrPartNumb = m_pcPic->getNumPartInCU() >> (uiDepth << 1);
   memset( m_puhCbf[g_aucConvertTxtTypeToIdx[eTType]] + uiAbsPartIdx, uiCbf, sizeof( UChar ) * uiCurrPartNumb );
@@ -2427,4 +2500,17 @@
   memset( m_skipFlag + absPartIdx, skip, m_pcPic->getNumPartInCU() >> ( 2 * depth ) );
 }
+
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+Void TComDataCU::setDISFlagSubParts( Bool bDIS, UInt absPartIdx, UInt depth )
+{
+    assert( sizeof( *m_bDISFlag) == 1 );
+    memset( m_bDISFlag + absPartIdx, bDIS, m_pcPic->getNumPartInCU() >> ( 2 * depth ) );
+}
+
+Void TComDataCU::setDISTypeSubParts(UInt uiDISType, UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth )
+{
+    setSubPartT( uiDISType, m_uiDISType, uiAbsPartIdx, uiDepth, uiPUIdx );
+}
+#else
 #if H_3D_SINGLE_DEPTH
 Void TComDataCU::setSingleDepthFlagSubParts( Bool singleDepth, UInt absPartIdx, UInt depth )
@@ -2439,4 +2525,6 @@
 }
 #endif
+#endif
+
 Void TComDataCU::setPredModeSubParts( PredMode eMode, UInt uiAbsPartIdx, UInt uiDepth )
 {
@@ -4109,4 +4197,5 @@
               }
             }
+#if !SHARP_SUBBLOCK_CLEAN_K0044
             if (iPUHeight + iPUWidth == 12)
             {
@@ -4117,4 +4206,5 @@
               }
             }
+#endif
 
             iPartition ++;
@@ -5332,4 +5422,20 @@
 }
 
+#if SONY_MV_V_CONST_C0078
+Void TComDataCU::checkMV_V (TComMv&  rcMv,  RefPicList eRefPicList, int iRefIdx )
+{
+  if ( getSlice()->getSPS()->getInterViewMvVertConstraintFlag() )
+  {
+    if ( getSlice()->getRefPic( eRefPicList, iRefIdx )->getPOC() == getSlice()->getPOC() )
+    {
+        //When inter_view_mv_vert_constraint_flag is equal to 1,
+        //the vertical component of the motion vectors used for inter-layer prediction 
+        //shall be equal to or less than 56 in units of luma samples
+        assert ( rcMv.getVer() <= (56<<2) );
+    }
+  }
+}
+#endif
+
 UInt TComDataCU::getIntraSizeIdx(UInt uiAbsPartIdx)
 {
@@ -5674,14 +5780,28 @@
   }
 
-  if ( bIsCurrRefLongTerm || bIsColRefLongTerm )
+  if ( bIsCurrRefLongTerm || bIsColRefLongTerm ) // CY: this condition equals to both bIsCurrRefLongTerm and bIsColRefLongTerm being 1
   {
 #if H_3D_TMVP
+#if !H_3D_FIX_TMVP_SCALING_VIEW_ID
     Int iCurrViewId    = m_pcSlice->getViewIndex (); 
     Int iCurrRefViewId = m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getViewIndex (); 
     Int iColViewId     = pColCU->getSlice()->getViewIndex(); 
     Int iColRefViewId  = pColCU->getSlice()->getRefPic( eColRefPicList, pColCU->getCUMvField(eColRefPicList)->getRefIdx(uiAbsPartAddr))->getViewIndex(); 
-    iScale = xGetDistScaleFactor( iCurrViewId, iCurrRefViewId, iColViewId, iColRefViewId );
-
+#else
+    Int iCurrViewId    = m_pcSlice->getViewId (); 
+    Int iCurrRefViewId = m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getViewId (); 
+    Int iColViewId     = pColCU->getSlice()->getViewId(); 
+    Int iColRefViewId  = pColCU->getSlice()->getRefPic( eColRefPicList, pColCU->getCUMvField(eColRefPicList)->getRefIdx(uiAbsPartAddr))->getViewId(); 
+#endif
+#if H_3D_TMVP_SCALING_FIX_K0053
+    iScale = 4096;
+    if ( iCurrRefViewId != iCurrViewId && iColViewId != iColRefViewId )
+#endif
+      iScale = xGetDistScaleFactor( iCurrViewId, iCurrRefViewId, iColViewId, iColRefViewId );
+#if H_3D_TMVP_FIX_TICKET_97 
+    if ( bMRG && iScale != 4096 && m_pcSlice->getIvMvScalingFlag( ) ) 
+#else
     if ( iScale != 4096 && m_pcSlice->getIvMvScalingFlag( ) )
+#endif
     {
       rcMv = cColMv.scaleMv( iScale );
@@ -5695,5 +5815,5 @@
 #endif
   }
-  else
+  else // CY: both bIsCurrRefLongTerm and bIsColRefLongTerm are 0
   {
     iScale = xGetDistScaleFactor(iCurrPOC, iCurrRefPOC, iColPOC, iColRefPOC);
@@ -5860,5 +5980,9 @@
 #endif
 #if H_3D_IV_MERGE
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+Void TComDataCU::getDispforDepth (UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDisp)
+#else
 Bool TComDataCU::getDispforDepth (UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDisp)
+#endif
 {
 
@@ -5876,15 +6000,71 @@
       pDisp->m_acNBDV = cMv;
       pDisp->m_aVIdxCan = iViewIdx;
-
+#if !SEC_ARP_REM_ENC_RESTRICT_K0035
       return true;
-  }
+#endif
+  }
+#if !SEC_ARP_REM_ENC_RESTRICT_K0035
   return false;
-}
-#endif
-
-#if H_3D_SINGLE_DEPTH
-Bool TComDataCU::getNeighDepth (UInt uiPartIdx, UInt uiPartAddr, Pel* pNeighDepth, Int index)
-{
-
+#endif
+}
+#endif
+
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+Bool TComDataCU::getNeighDepth ( UInt uiPartIdx, UInt uiPartAddr, Pel* pNeighDepth, Int index )
+{
+#if NEIGHBORING_PIX_AVAILABILITY_FIX
+  UInt  uiPartIdxLT, uiPartIdxRT;
+  this->deriveLeftRightTopIdxAdi( uiPartIdxLT, uiPartIdxRT, 0, 0 );
+  UInt uiMidPart, uiPartNeighbor;  
+  TComDataCU* pcCUNeighbor;
+  Bool bDepAvail = false;
+  Pel *pDepth  = this->getPic()->getPicYuvRec()->getLumaAddr();
+  Int iDepStride =  this->getPic()->getPicYuvRec()->getStride();
+
+  Int xP, yP, nPSW, nPSH;
+  this->getPartPosition( uiPartIdx, xP, yP, nPSW, nPSH );
+
+  switch( index )
+  {
+  case 0: // Mid Left
+    uiMidPart = g_auiZscanToRaster[uiPartIdxLT] + (nPSH>>1) / this->getPic()->getMinCUHeight() * this->getPic()->getNumPartInWidth();
+    pcCUNeighbor = this->getPULeft( uiPartNeighbor, g_auiRasterToZscan[uiMidPart] );
+    if ( pcCUNeighbor )
+    {
+      if( !this->getSlice()->getPPS()->getConstrainedIntraPred() )
+      {
+        *pNeighDepth = pDepth[ (yP+(nPSH>>1)) * iDepStride + (xP-1) ];
+        bDepAvail = true;
+      }
+      else if ( pcCUNeighbor->getPredictionMode( uiPartNeighbor ) == MODE_INTRA )
+      {
+        *pNeighDepth = pDepth[ (yP+(nPSH>>1)) * iDepStride + (xP-1) ];
+        bDepAvail = true;
+      }
+    }
+    break;
+  case 1: // Mid Above
+    uiMidPart = g_auiZscanToRaster[uiPartIdxLT] + (nPSW>>1) / this->getPic()->getMinCUWidth();
+    pcCUNeighbor = this->getPUAbove( uiPartNeighbor, g_auiRasterToZscan[uiMidPart] );
+    if( pcCUNeighbor )
+    {
+      if( !this->getSlice()->getPPS()->getConstrainedIntraPred() )
+      {
+        *pNeighDepth = pDepth[ (yP-1) * iDepStride + (xP + (nPSW>>1)) ];
+        bDepAvail = true;
+      }
+      else if ( pcCUNeighbor->getPredictionMode( uiPartNeighbor ) == MODE_INTRA )
+      {
+        *pNeighDepth = pDepth[ (yP-1) * iDepStride + (xP + (nPSW>>1)) ];
+        bDepAvail = true;
+      }
+    }
+    break;
+  default:
+    break;
+  }
+
+  return bDepAvail;
+#else
   Bool bDepAvail = false;
   Pel *pDepth  = this->getPic()->getPicYuvRec()->getLumaAddr();
@@ -5912,10 +6092,46 @@
     break;
   default:
+    break;
+  }
+  return bDepAvail;
+#endif
+}
+#else
+#if H_3D_SINGLE_DEPTH
+Bool TComDataCU::getNeighDepth (UInt uiPartIdx, UInt uiPartAddr, Pel* pNeighDepth, Int index)
+{
+
+  Bool bDepAvail = false;
+  Pel *pDepth  = this->getPic()->getPicYuvRec()->getLumaAddr();
+  Int iDepStride =  this->getPic()->getPicYuvRec()->getStride();
+
+  Int xP, yP, nPSW, nPSH;
+  this->getPartPosition(uiPartIdx, xP, yP, nPSW, nPSH);
+  UInt PicHeight=this->getPic()->getPicYuvRec()->getHeight();
+  UInt PicWidth=this->getPic()->getPicYuvRec()->getWidth();
+  switch(index)
+  {
+  case 0: // Mid Left
+    if( ( xP != 0 ) && ( ( yP + ( nPSH >> 1 ) ) < PicHeight ) )
+    {
+      *pNeighDepth = pDepth[ (yP+(nPSH>>1)) * iDepStride + (xP-1) ];
+      bDepAvail = true;
+    }
+    break;
+  case 1: // Mid Above
+    if( ( yP != 0 ) && ( ( xP + ( nPSW >> 1 ) ) < PicWidth ) )
+    {
+      *pNeighDepth = pDepth[ (yP-1) * iDepStride + (xP + (nPSW>>1)) ];
+      bDepAvail = true;
+    }
+    break;
+  default:
       break;
   }
   return bDepAvail;
 }
-
-#endif
+#endif
+#endif
+
 #if H_3D_NBDV 
 //Notes from QC:
@@ -5923,5 +6139,9 @@
 //TBD#2: set of DvMCP values need to be done as part of inter-view motion prediction process. Remove this comment once merge related integration is done
 //To be checked: Parallel Merge features for NBDV, related to DV_DERIVATION_PARALLEL_B0096 and LGE_IVMP_PARALLEL_MERGE_B0136 are not integrated. The need of these features due to the adoption of CU-based NBDV is not clear. We need confirmation on this, especially by proponents
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+Void TComDataCU::getDisMvpCandNBDV( DisInfo* pDInfo
+#else
 Bool TComDataCU::getDisMvpCandNBDV( DisInfo* pDInfo
+#endif
 #if H_3D_NBDV_REF
 , Bool bDepthRefine
@@ -5931,5 +6151,7 @@
   //// ******* Init variables ******* /////
   // Init disparity struct for results
+#if !SEC_ARP_REM_ENC_RESTRICT_K0035
   pDInfo->bDV = false;   
+#endif
   pDInfo->m_aVIdxCan = -1;
 
@@ -6026,5 +6248,9 @@
         pDInfo->m_acDoNBDV  = cColMv;
 #endif //H_3D_NBDV_REF
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+        return;
+#else
         return true;
+#endif
       }
     }
@@ -6043,5 +6269,9 @@
 #endif
     ) )
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+    return;
+#else
     return true;
+#endif
 
   //// ******* Get disparity from above block ******* /////
@@ -6055,5 +6285,9 @@
 #endif
       ) )
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+      return;
+#else
       return true;
+#endif
   }
 
@@ -6101,5 +6335,9 @@
           pDInfo->m_acDoNBDV = cDispVec;
 #endif
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+          return;
+#else
           return true;
+#endif
         }
       }
@@ -6137,7 +6375,11 @@
       pDInfo->m_acDoNBDV = defaultDV;
 #endif
+#if !SEC_ARP_REM_ENC_RESTRICT_K0035
       return true;
-  }
+#endif
+  }
+#if !SEC_ARP_REM_ENC_RESTRICT_K0035
   return false; 
+#endif
 }
 
@@ -6712,4 +6954,5 @@
 
               }
+#if !SHARP_SUBBLOCK_CLEAN_K0044
               if (iSPHeight + iSPWidth == 12)
               {
@@ -6720,4 +6963,5 @@
                 }
               }
+#endif
               iPartition ++;
             }
@@ -6752,6 +6996,11 @@
       Int         iBaseAbsPartIdx;
 
+#if SEC_SHIFTED_IVMC_POS_K0036
+      Int offsetW = (iLoopCan == 0) ? 0 : ( iWidth  * 2 );
+      Int offsetH = (iLoopCan == 0) ? 0 : ( iHeight * 2 );
+#else
       Int offsetW = (iLoopCan == 0) ? 0 : ( ((iWidth /2)*4) + 4 );
       Int offsetH = (iLoopCan == 0) ? 0 : ( ((iHeight/2)*4) + 4 );
+#endif
 
       Int         iBasePosX   = Clip3( 0, pcBaseRec->getWidth () - 1, iCurrPosX + ( (cDv.getHor() + offsetW + 2 ) >> 2 ) );
Index: /trunk/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComDataCU.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -110,7 +110,12 @@
   // -------------------------------------------------------------------------------------------------------------------
   Bool*         m_skipFlag;           ///< array of skip flags
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  Bool*         m_bDISFlag;         
+  UInt*         m_uiDISType;
+#else
 #if H_3D_SINGLE_DEPTH
   Bool*         m_singleDepthFlag;           ///< array of single depth flags
   Pel*          m_apSingleDepthValue;
+#endif
 #endif
   Char*         m_pePartSize;         ///< array of partition sizes
@@ -308,4 +313,7 @@
   TComPic*      getPic                ()                        { return m_pcPic;           }
   TComSlice*    getSlice              ()                        { return m_pcSlice;         }
+#if H_3D_DISABLE_CHROMA
+  Void         setSlice              ( TComSlice* pcSlice)     { m_pcSlice = pcSlice;       }
+#endif
   UInt&         getAddr               ()                        { return m_uiCUAddr;        }
   UInt&         getZorderIdxInCU      ()                        { return m_uiAbsIdxInLCU; }
@@ -342,4 +350,15 @@
   Void         setSkipFlag           ( UInt idx, Bool skip)     { m_skipFlag[idx] = skip;   }
   Void         setSkipFlagSubParts   ( Bool skip, UInt absPartIdx, UInt depth );
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  Bool*        getDISFlag            ()                         { return m_bDISFlag;          }
+  Bool         getDISFlag            ( UInt idx)                { return m_bDISFlag[idx];     }
+  Void         setDISFlag            ( UInt idx, Bool bDIS)     { m_bDISFlag[idx] = bDIS;   }
+  Void         setDISFlagSubParts    ( Bool bDIS, UInt absPartIdx, UInt depth );
+
+  UInt*        getDISType            ()                         { return m_uiDISType; }
+  UInt         getDISType            ( UInt idx)                { return m_uiDISType[idx];     }
+  Void         getDISType            ( UInt idx, UInt uiDISType)     { m_uiDISType[idx] = uiDISType;   }
+  Void         setDISTypeSubParts    ( UInt uiDISType, UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth );
+#else
 #if H_3D_SINGLE_DEPTH
   Bool*        getSingleDepthFlag            ()                        { return m_singleDepthFlag;          }
@@ -353,4 +372,5 @@
   Void         setSingleDepthValueSubParts   (Pel singleDepthValue, UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth );
 #endif  
+#endif
   Char*         getPredictionMode     ()                        { return m_pePredMode;        }
   PredMode      getPredictionMode     ( UInt uiIdx )            { return static_cast<PredMode>( m_pePredMode[uiIdx] ); }
@@ -418,6 +438,8 @@
   UChar         getCbf    ( UInt uiIdx, TextType eType )                  { return m_puhCbf[g_aucConvertTxtTypeToIdx[eType]][uiIdx];  }
   UChar*        getCbf    ( TextType eType )                              { return m_puhCbf[g_aucConvertTxtTypeToIdx[eType]];         }
+
   UChar         getCbf    ( UInt uiIdx, TextType eType, UInt uiTrDepth )  { return ( ( getCbf( uiIdx, eType ) >> uiTrDepth ) & 0x1 ); }
   Void          setCbf    ( UInt uiIdx, TextType eType, UChar uh )        { m_puhCbf[g_aucConvertTxtTypeToIdx[eType]][uiIdx] = uh;    }
+
   Void          clearCbf  ( UInt uiIdx, TextType eType, UInt uiNumParts );
   UChar         getQtRootCbf          ( UInt uiIdx )                      { return getCbf( uiIdx, TEXT_LUMA, 0 ) || getCbf( uiIdx, TEXT_CHROMA_U, 0 ) || getCbf( uiIdx, TEXT_CHROMA_V, 0 ); }
@@ -484,5 +506,9 @@
   );
   Bool          xGetColDisMV      ( Int currCandPic, RefPicList eRefPicList, Int refidx, Int uiCUAddr, Int uiPartUnitIdx, TComMv& rcMv, Int & iTargetViewIdx, Int & iStartViewIdx );
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+  Void          getDisMvpCandNBDV ( DisInfo* pDInfo
+#else
   Bool          getDisMvpCandNBDV ( DisInfo* pDInfo
+#endif
 #if H_3D_NBDV_REF
    , Bool bDepthRefine = false
@@ -491,9 +517,17 @@
    
 #if H_3D
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+  Void          getDispforDepth  ( UInt uiPartIdx, UInt uiPartAddr, DisInfo* cDisp);
+#else
   Bool          getDispforDepth  ( UInt uiPartIdx, UInt uiPartAddr, DisInfo* cDisp);
+#endif
   Bool          getDispMvPredCan(UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, Int* paiPdmRefIdx, TComMv* pacPdmMv, DisInfo* pDis, Int* iPdm );
 #endif
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+   Bool          getNeighDepth (UInt uiPartIdx, UInt uiPartAddr, Pel* pNeighDepth, Int index);
+#else
 #if H_3D_SINGLE_DEPTH
    Bool          getNeighDepth (UInt uiPartIdx, UInt uiPartAddr, Pel* pNeighDepth, Int index);
+#endif
 #endif
 #if H_3D_NBDV_REF
@@ -591,4 +625,7 @@
   
   Void          clipMv                ( TComMv&     rcMv     );
+#if SONY_MV_V_CONST_C0078
+  Void          checkMV_V (TComMv&  rcMv,  RefPicList eRefPicList, int iRefIdx );
+#endif
   Void          getMvPredLeft         ( TComMv&     rcMvPred )   { rcMvPred = m_cMvFieldA.getMv(); }
   Void          getMvPredAbove        ( TComMv&     rcMvPred )   { rcMvPred = m_cMvFieldB.getMv(); }
Index: /trunk/source/Lib/TLibCommon/TComInterpolationFilter.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComInterpolationFilter.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComInterpolationFilter.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComInterpolationFilter.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComInterpolationFilter.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComInterpolationFilter.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComList.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComList.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComList.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComLoopFilter.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComLoopFilter.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComLoopFilter.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComLoopFilter.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComMotionInfo.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComMotionInfo.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComMotionInfo.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComMotionInfo.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComMotionInfo.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -63,5 +63,7 @@
 typedef struct _DisCand 
 {
+#if !SEC_ARP_REM_ENC_RESTRICT_K0035
   Bool bDV;
+#endif
   TComMv m_acNBDV;              // DV from NBDV
 #if H_3D_NBDV_REF 
Index: /trunk/source/Lib/TLibCommon/TComMv.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComMv.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComMv.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComPattern.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPattern.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPattern.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComPattern.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPattern.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPattern.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPic.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComPic.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPic.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPic.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComPicSym.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicSym.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPicSym.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComPicSym.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicSym.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPicSym.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
